This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 982351 - Review Request: python-jsonpointer - Resolve JSON Pointers in Python
Review Request: python-jsonpointer - Resolve JSON Pointers in Python
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 982352
  Show dependency treegraph
 
Reported: 2013-07-08 14:45 EDT by Dan Prince
Modified: 2013-10-12 00:30 EDT (History)
8 users (show)

See Also:
Fixed In Version: python-jsonpointer-1.0-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1019279 (view as bug list)
Environment:
Last Closed: 2013-10-09 20:59:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Dan Prince 2013-07-08 14:45:05 EDT
Spec URL: http://dprince.fedorapeople.org/python-jsonpointer.spec
SRPM URL: http://dprince.fedorapeople.org/python-jsonpointer-0.7-1.fc18.src.rpm
Description: Resolve JSON Pointers in Python
Fedora Account System Username: dprince
Comment 1 Alan Pevec 2013-07-08 15:29:05 EDT
Quick summary from fedora-review, other than that looks good.

Issues:
=======
- Package contains BR: python2-devel or python3-devel
  See: http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

Rpmlint
-------
Checking: python-jsonpointer-0.7-1.fc19.noarch.rpm
python-jsonpointer.noarch: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
=> no idea what's that about, it's not in spec, ignore

python-jsonpointer.noarch: W: incoherent-version-in-changelog 0.7.0-1 ['0.7-1.fc19', '0.7-1']
=> that should be fixed

python-jsonpointer.noarch: W: no-documentation
=> add %doc README.md to make it happy
Comment 2 Mario Blättermann 2013-07-10 16:45:00 EDT
The tarball contains the license "Modified BSD". As far as I can see, we don't have such a license under "good licenses". Needs to be investigated.

BuildRequires:  python-devel
This is deprecated, as already mentioned by Alan. Use python2-devel instead.
Comment 3 Eduardo Echeverria 2013-07-11 02:37:00 EDT
This is not the latest version of this package, there are one more newer

https://pypi.python.org/pypi/jsonpointer/1.0

pypi's tarball doesn't contains the boilerplate of the license, but is in the github's repository    

https://github.com/stefankoegl/python-json-pointer/blob/master/COPYING

you can do two things
- download the boilerplate of the pypi site and insert in the package via SourceN
or
- packaging via github.

if you choose the second, see https://fedoraproject.org/wiki/Packaging:SourceURL#Github

@Mario 3-clause license of the BSD License is known as  "Revised BSD License", "New BSD License", or "Modified BSD License"
https://fedoraproject.org/wiki/Licensing:BSD?rd=Licensing/BSD#3ClauseBSD
Comment 4 Alan Pevec 2013-08-12 20:28:26 EDT
Dan, do you want me to take this and python-jsonpatch reviews?
Comment 5 Alan Pevec 2013-08-16 14:35:43 EDT
Dan is ok that I take this package, so here are new spec and SRPM, using github tarball:

Spec URL: http://apevec.fedorapeople.org/python-jsonpointer.spec
SRPM URL: http://apevec.fedorapeople.org/python-jsonpointer-1.0-1.fc20.src.rpm
Description: Resolve JSON Pointers in Python
Fedora Account System Username: apevec
Comment 6 Mario Blättermann 2013-08-27 15:38:03 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5862403

$ rpmlint -i -v *
python-jsonpointer.noarch: I: checking
python-jsonpointer.noarch: I: checking-url https://github.com/stefankoegl/python-json-pointer (timeout 10 seconds)
python-jsonpointer.src: I: checking
python-jsonpointer.src: I: checking-url https://github.com/stefankoegl/python-json-pointer (timeout 10 seconds)
python-jsonpointer.src: I: checking-url https://github.com/stefankoegl/python-json-pointer/archive/c1ec3dfd171b242e23b3fe078a99f0e23fb0c6ea/python-json-pointer-1.0-c1ec3df.tar.gz (timeout 10 seconds)
python-jsonpointer.spec: I: checking-url https://github.com/stefankoegl/python-json-pointer/archive/c1ec3dfd171b242e23b3fe078a99f0e23fb0c6ea/python-json-pointer-1.0-c1ec3df.tar.gz (timeout 10 seconds)
2 packages and 1 specfiles checked; 0 errors, 0 warnings.


Referring to rpmlint, your package is OK. But shouldn't be the %check section after %install? Maybe it is important to run the tests after installation. All Python packages I've reviewed do so.

Moreover, I'm missing AUTHORS in %doc.
Comment 7 Alan Pevec 2013-09-05 07:30:59 EDT
Thanks for the review Mario and thanks Christopher for the needinfo ping, that made it jump out of BZ spam :)

> Referring to rpmlint, your package is OK. But shouldn't be the %check
> section after %install? Maybe it is important to run the tests after
> installation. All Python packages I've reviewed do so.

It is actually documented[1] that %check follows %build, also tests run in the builddir directory, code installed in buildrootdir is not used.
I guess other packages follow rpmbuild execution order which runs %check after %install no matter what order is it in spec.
There are also other Fedora py rpms which have %build %check %install order e.g.
 http://pkgs.fedoraproject.org/cgit/python-prettytable.git/tree/python-prettytable.spec 

> Moreover, I'm missing AUTHORS in %doc.

Added.


[1] http://fedoraproject.org/wiki/How_to_create_an_RPM_package#.25check_section

Spec URL: http://apevec.fedorapeople.org/python-jsonpointer.spec
SRPM URL: http://apevec.fedorapeople.org/python-jsonpointer-1.0-2.fc20.src.rpm
Description: Resolve JSON Pointers in Python
Fedora Account System Username: apevec
Comment 8 Michael Schwendt 2013-09-05 08:04:24 EDT
The HowTo is wrong.

IMO, %check should be placed after the %install section, because rpmbuild executes it after %install. And because in some cases one performs tests on the files in %buildroot rather than uninstalled files in the builddir.

I could edit the Wiki, but would first like to hear why the HowTo claims %check come directly after %build:
https://lists.fedoraproject.org/pipermail/packaging/2013-September/009491.html
Comment 9 Mario Blättermann 2013-09-05 13:34:06 EDT
New scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5900463

$ rpmlint -i -v *
python-jsonpointer.noarch: I: checking
python-jsonpointer.noarch: I: checking-url https://github.com/stefankoegl/python-json-pointer (timeout 10 seconds)
python-jsonpointer.src: I: checking
python-jsonpointer.src: I: checking-url https://github.com/stefankoegl/python-json-pointer (timeout 10 seconds)
python-jsonpointer.src: I: checking-url https://github.com/stefankoegl/python-json-pointer/archive/c1ec3dfd171b242e23b3fe078a99f0e23fb0c6ea/python-json-pointer-1.0-c1ec3df.tar.gz (timeout 10 seconds)
python-jsonpointer.spec: I: checking-url https://github.com/stefankoegl/python-json-pointer/archive/c1ec3dfd171b242e23b3fe078a99f0e23fb0c6ea/python-json-pointer-1.0-c1ec3df.tar.gz (timeout 10 seconds)
2 packages and 1 specfiles checked; 0 errors, 0 warnings.

No new issues, no further objections from my side.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    BSD
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    29186ed95ef02c320a8fe8f17994472c7fefd493072aebcd8b244053cb66f4c6  python-json-pointer-1.0-c1ec3df.tar.gz
    29186ed95ef02c320a8fe8f17994472c7fefd493072aebcd8b244053cb66f4c6  python-json-pointer-1.0-c1ec3df.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[.] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


----------------

PACKAGE APPROVED

----------------
Comment 10 Alan Pevec 2013-09-12 10:00:38 EDT
New Package SCM Request
=======================
Package Name: python-jsonpointer
Short Description: Resolve JSON Pointers in Python
Owners: apevec dprince
Branches: f19 f20 el6
InitialCC:
Comment 11 Gwyn Ciesla 2013-09-12 10:12:37 EDT
Git done (by process-git-requests).
Comment 12 Alan Pevec 2013-09-12 17:32:11 EDT
Closed-Rawhide was premature, I'll close tomorrow when it should really reach Rawhide repos.
Comment 13 Fedora Update System 2013-09-26 17:57:15 EDT
python-jsonpointer-1.0-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/python-jsonpointer-1.0-2.fc20
Comment 14 Fedora Update System 2013-09-26 18:01:43 EDT
python-jsonpointer-1.0-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-jsonpointer-1.0-2.fc19
Comment 15 Fedora Update System 2013-09-27 20:18:15 EDT
python-jsonpointer-1.0-2.fc19 has been pushed to the Fedora 19 testing repository.
Comment 16 Fedora Update System 2013-10-09 20:59:52 EDT
python-jsonpointer-1.0-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 17 Fedora Update System 2013-10-12 00:30:46 EDT
python-jsonpointer-1.0-2.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.